package at.cosimo.verocl.metamodel.output;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcoreFactory;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EAttributeImpl;
import org.eclipse.emf.ecore.impl.EClassImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;

public class EObjectBase extends MinimalEObjectImpl implements EObject  {
	
	public static final EClass eclass;
	public static final EClass staticeclass;
	
	public static final EAttribute attribute;
	
	public static final EPackage epkg;
	
	static {
		epkg = EcoreFactory.eINSTANCE.createEPackage();
		epkg.setName("Test");
	}
	
	static {
		staticeclass = EcoreFactory.eINSTANCE.createEClass();
		staticeclass.setName("StaticEObjectBase");
		
		eclass = EcoreFactory.eINSTANCE.createEClass();
		eclass.setInstanceClass(EObjectBase.class);
		epkg.getEClassifiers().add(eclass);
		
		EAttribute attr = EcoreFactory.eINSTANCE.createEAttribute();
		attribute = attr;
		attr.setName("x");
		attr.setEType(EcorePackage.Literals.ESTRING);
		eclass.setName("Test");
		eclass.getEStructuralFeatures().add(attr);
		((EAttributeImpl)attr).setContainerClass(EObjectBase.class);
		System.out.println("Container: " + attr.getContainerClass());
		System.out.println("Container2: " + attr.eContainer());
		
		eclass.getEAllStructuralFeatures();
		try {
			Method m = ((EClassImpl) eclass).getClass().getDeclaredMethod("getEAllStructuralFeaturesData");
			m.setAccessible(true);
			m.invoke(eclass);
		} catch (IllegalAccessException | IllegalArgumentException
				| InvocationTargetException | NoSuchMethodException
				| SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	{
		this.eSetClass(eclass);
	}
	
	protected EClass eStaticClass()
	{
	    return EObjectBase.staticeclass;
	}
	
	public static void main(String[] args) {
		EObjectBase base = new EObjectBase();
		System.out.println("Attribute:" + base.eGet(attribute));
		base.eSet(attribute, "Value");
		System.out.println("Attribute:" + base.eGet(attribute));
	}

}
