package at.cosimo.verocl.metamodel.output;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

public class OutputPackage {
	
	public OutputPackage(String name, OutputPackage superPackage) {
		this.name = name;
		this.superPackage = superPackage;
	}
	
	private EObject eobj;

	private String name;
	private OutputPackage superPackage;
	private List<OutputClass> outputClasses = new ArrayList<>();
	
	public List<OutputClass> getContainedClasses() {
		if (eobj == null) {
			eobj = null;
		}
		return outputClasses;
	}
	
	public void addContainedClass(OutputClass cl) {
		outputClasses.add(cl);
		cl.setPackage(this);
	}
	
	public String getName() {
		return name;
	}
	
	public String getFullName() {
		if (superPackage != null) {
			return superPackage.getFullName()+"."+name;
		}
		return name;
	}
}
