package at.cosimo.verocl.template;

public interface FunctionCallProvider {

	public FunctionCall getFunctionCall(String name);
	
	public static final FunctionCallProvider defaultProvider = new FunctionCallProvider() {
		
		@Override
		public FunctionCall getFunctionCall(String name) {
			switch (name) {
				case "instanceOf": return new InstanceOf();
				case "etypeToString": return new ETypeToString();
				case "etypeToEString": return new ETypeToEString();
				case "firstUpper": return new FirstUpper();
				case "needsCollectionConversion": return new NeedsCollectionConversion();
				default: return null;
			}
		}
	};
	
	
	public static FunctionCallProvider defaultProvider() {
		return defaultProvider;
	}
}
