package at.cosimo.verocl.template;

public interface TemplateProcessorProvider {

	public TemplateProcessorIFace getTemplateProcessor(String name);
	
	public static final TemplateProcessorProvider defaultProvider = new TemplateProcessorProvider() {
		
		@Override
		public TemplateProcessorIFace getTemplateProcessor(String name) {
			switch (name) {
				case "forAll": return new ForAllProcessor();
				case "ifEq": return new IfEqProcessor();
				case "else": return new ElseProcessor();
				case "check": return new CheckProcessor();
				case "set": return new SetProcessor();
				default: return null;
			}
		}
	};
	
	public static TemplateProcessorProvider defaultProvider() {
		return defaultProvider;
	}
}
