package at.cosimo.verocl.template;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;

public class TemplateSimpleProd {

	public String escape(String str) {
		return "\""+str.replace("\\", "\\\\").replace("\"", "\\\"").replace("\n", "\\n").replace("\t", "\\t")+"\\n\"";
	}
	
	File baseFile;
	PrintWriter writer;
	
	public void process(File file) {
		if (file.isDirectory()) {
			for (File sub: file.listFiles()) {
				process(sub);
			}
		} else {
			String sup = file.getAbsolutePath().substring(baseFile.getAbsolutePath().length()).replace("\\", "\\\\");
			if (sup.startsWith("\\")) {
				sup = sup.substring(2);
			}
			writer.write("\t\tTemplateProcessorIFace.addTemplateMap(\""+sup+"\",s = ");
			boolean first = true;
			try (BufferedReader reader = new BufferedReader(new FileReader(file))) {
				String s;
				while ((s = reader.readLine()) != null) {
					if (first) {first = false;} else {writer.write(" + ");}
					writer.write(escape(s)+"\n");
				}
			} catch (Exception e) {
				System.err.println(e.getMessage());
			}
			writer.write(");\n");
			writer.write("\t\tTemplateProcessorIFace.addTemplateMap(\""+sup.replace("\\\\", "/")+"\",s);\n");
			writer.write("\t\tTemplateProcessorIFace.addTemplateMap(\"\\"+sup+"\",s);\n");
			writer.write("\t\tTemplateProcessorIFace.addTemplateMap(\"/"+sup.replace("\\\\", "/")+"\",s);\n");
			
		}
	}
	
	public void doForDir(File baseDir, File initDir, String pkg, String name) throws FileNotFoundException {
		writer = new PrintWriter("src"+File.separator+pkg.replace('.', File.separatorChar)+File.separatorChar+name+".java");
		writer.append("package "+pkg+";\n\npublic class "+name+" {\n\tpublic static void execute() {\nString s = null;\n");
		baseFile = baseDir;
		process(initDir);
		writer.append("\t}\n}");
		writer.flush();
		writer.close();
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		TemplateSimpleProd test = new TemplateSimpleProd();
		test.doForDir(new File(""), new File("templates"), "at.cosimo.verocl.template","TemplateInserter");
	}
}
