package at.cosimo.verocl.util.ecore;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import javax.annotation.processing.Filer;
import javax.lang.model.element.Element;
import javax.lang.model.element.TypeElement;
import javax.tools.FileObject;
import javax.tools.JavaFileManager;
import javax.tools.JavaFileObject;
import javax.tools.StandardLocation;
import javax.tools.Diagnostic.Kind;


public class AITest {

	
	public static void mainMethod2(List<EcoreVMClone> testList) {
		boolean haveAnnot = false;
		Map<String,String> annotationNames = new HashMap<String, String>();
		StringBuilder input = new StringBuilder();
		for (EcoreVMClone annotation: testList) {
				haveAnnot = true;
			//}
			//for (EcoreVM annotation: elem.getAnnotationsByType(EcoreVM.class)) {
			StringBuilder builder = new StringBuilder();
			boolean first = true;
			for (String ecore: annotation.ecoreFiles()) {
				if (first) {first = false;} else {builder.append(", ");}
				builder.append(ecore);
			}
			annotationNames.put(annotation.name,annotation.name());
			input.append("+"+annotation.name()+"\n");
			for (String ecore: annotation.ecoreFiles()) {
				input.append("#"+ecore+"\n");
			}
		}
		
		String sourcePath = "";
		File res = null;		
		try {
			res = new File("id.txt");
			BufferedReader reader = new BufferedReader(new FileReader(res));
			String s;
			while ((s = reader.readLine()) != null) {
				if (s.isEmpty()) {continue;}
				String[] pre = s.split("@");
				//Long fileDate = Long.valueOf(pre[1]);
				String[] annot = pre[0].split(":");
				if (annot.length > 0) {
					annotationNames.put(annot[0],annot[1]);
				} else {
					annotationNames.put(annot[0],annot[0]);
				}
			}
		} catch (IOException e2) {
			e2.printStackTrace();
		}
		
		

		
		if (!haveAnnot) {
			return;
		}
		
		
		try {
			res = new File("id.txt");
			StringBuilder builder = new StringBuilder();
			for (Entry<String,String> entry: annotationNames.entrySet()) {
				builder.append(entry.getKey()+":"+entry.getValue());
				builder.append("\n");
			}
			PrintWriter writer = new PrintWriter(res);
			writer.append(builder.toString());
			writer.flush();
			writer.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		
		input.append("\n");
		
		for (String infoStr: annotationNames.keySet()) {
			try {
				//Paketname, verwendete Ecore-Dateien
				//+Paketname
				//#Ecore-File1...
				//#Ecore-Filen
				//:fullyqualifiedname:EClassURI
				//<subclass<superclass
				//
				res = new File("src"+File.separator+infoStr.replace('.', File.separatorChar)+File.separator+ "info.txt");
				input.append("?="+infoStr+"\n");
				try (BufferedReader reader = new BufferedReader(new FileReader(res))) {
					String s;
					List<String> ecoreFiles = new ArrayList<>();
					Map<String,String> eclassUris = new HashMap<>();
					Map<String,Collection<String>> subToSuper = new HashMap<>();
					while ((s = reader.readLine()) != null) {
						if (s.isEmpty()) {continue;}
						if (s.startsWith("+")) {
							ecoreFiles.add(s.substring(1));
							input.append("?"+s+"\n");
						} else if (s.startsWith("<")) {
							String[] spl = s.substring(1).split("<");
							Collection<String> sup = subToSuper.get(spl[0]);
							if (sup == null) {
								subToSuper.put(spl[0],sup = new ArrayList<>());
							}
							sup.add(spl[1]);
							input.append("?"+s+"\n");
						} else if (s.startsWith(":")) {
							String[] spl = s.substring(1).split(":",2);
							eclassUris.put(spl[0], spl[1]);
							input.append("?"+s+"\n");
						}
					}
				}
				
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		
		StringBuilder output = new StringBuilder();
		try {
			ByteArrayInputStream bis = new ByteArrayInputStream(input.toString().getBytes());
			BufferedReader br = new BufferedReader(new InputStreamReader(bis));
			StringWriter sw = new StringWriter();
			BufferedWriter wri = new BufferedWriter(sw);
			AnnotationIface.doMain(br, wri);
			br.close();
			wri.flush();
			wri.close();
			//p = Runtime.getRuntime().exec("java -jar \"" + Paths.get("lib"+File.separator+"annot.jar").toAbsolutePath().toString()+"\" \""+StandardLocation.SOURCE_OUTPUT+"\"");
			/*InputStream is = p.getInputStream();
			
			BufferedReader reader = new BufferedReader(new InputStreamReader(is));*/
			BufferedReader reader = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(sw.getBuffer().toString().getBytes())));
			
			/*
			OutputStream os = p.getOutputStream();
			os.write(input.toString().getBytes());
			os.flush();
			os.close();*/
			
			String s;
			StringBuilder cur = new StringBuilder();
			Map<String,String> packageToJavaMap = new HashMap<>();
			String curName = null;
			
			
			while ((s = reader.readLine()) != null) {
				output.append(s);
				output.append("\n");
				if (s.isEmpty()) {continue;}
				if (s.startsWith("+")) {
					if (curName != null) {
						packageToJavaMap.put(curName, cur.toString());
						cur = new StringBuilder();
					}
					curName = s.substring(1);
					//idwriter.append(curName+"\n");
				} else if (s.startsWith("#")) {
					cur.append(s.substring(1));
					cur.append("\n");
				}
				
			}
			
			if (curName != null) {
				packageToJavaMap.put(curName, cur.toString());
			}
			
			/*BufferedReader errReader = new BufferedReader(new InputStreamReader(p.getErrorStream()));
			
			while ((s = errReader.readLine()) != null) {
				output.append(s);
				output.append("\n");
			}*/
			
			
			

			
			for (Entry<String,String> entry: packageToJavaMap.entrySet()) {
				if (entry.getKey().endsWith("info-txt")) {
					int lastPoint = entry.getKey().lastIndexOf('.');
					String pkg = "";
					String name = entry.getKey().replace('-', '.');
					if (lastPoint != -1) {
						pkg = entry.getKey().substring(0,lastPoint);
						name = entry.getKey().substring(lastPoint+1).replace('-', '.');
					}
					File fo = new File("src"+File.separator+pkg.replace('.',File.separatorChar)+File.separator+ name);
					fo.getParentFile().mkdirs();
					Writer writer = new PrintWriter(fo);
					writer.write(entry.getValue());
					writer.flush();
					writer.close();
				} else {
					File jfo = new File("src"+File.separator+entry.getKey().replace('.', File.separatorChar)+".java");
					System.out.println("Writing file " + jfo);
					jfo.getParentFile().mkdirs();
					Writer writer = new PrintWriter(jfo);
					writer.write(entry.getValue());
					
					writer.flush();
					writer.close();
				}
			}
			
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	public static void mainMethod(List<EcoreVMClone> testList) {
		StringBuilder inputBuilder = new StringBuilder();
		Set<String> addAnnotationNames = new HashSet<>();
		for (EcoreVMClone evm: testList) {
			inputBuilder.append(evm.toString());
			addAnnotationNames.add(evm.name());
		}
		String inputStr = inputBuilder.toString();
		String sourcePath = "";
		File res = null;
		StringBuilder input = new StringBuilder();
		try {
			res = new File("src/id.txt");
			BufferedReader reader = new BufferedReader(new FileReader(res));
			String s;
			while ((s = reader.readLine()) != null) {
				if (s.isEmpty()) {continue;}
				addAnnotationNames.add(s);
			}
		} catch (IOException e1) {
			
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		try {

			Writer idwriter = new BufferedWriter(new FileWriter(res));
			StringBuilder builder = new StringBuilder();
			for (String s: addAnnotationNames) {
				builder.append(s);
				builder.append("\n");
			}
			idwriter.append(builder.toString());
			idwriter.flush();
			idwriter.close();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		input.append(inputStr);
		
		try {
			StringBuilder builder = new StringBuilder();
			for (String s: addAnnotationNames) {
				builder.append(s);
				builder.append("\n");
			}
			Writer writer = new FileWriter(res);
			writer.append(builder.toString());
			writer.flush();
			writer.close();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		input.append("\n");
		
		for (String infoStr: addAnnotationNames) {
			try {
				//Paketname, verwendete Ecore-Dateien
				//+Paketname
				//#Ecore-File1...
				//#Ecore-Filen
				//:fullyqualifiedname:EClassURI
				//<subclass<superclass
				//
				res = new File("src"+File.separator+infoStr.replace('.',File.separatorChar)+File.separatorChar+"info.txt");
				input.append("?="+infoStr+"\n");
				res.getParentFile().mkdirs();
				BufferedReader reader = new BufferedReader(new FileReader(res));
				String s;
				List<String> ecoreFiles = new ArrayList<>();
				Map<String,String> eclassUris = new HashMap<>();
				Map<String,Collection<String>> subToSuper = new HashMap<>();
				while ((s = reader.readLine()) != null) {
					if (s.isEmpty()) {continue;}
					if (s.startsWith("+")) {
						ecoreFiles.add(s.substring(1));
						input.append("?"+s+"\n");
					} else if (s.startsWith("<")) {
						String[] spl = s.substring(1).split("<");
						Collection<String> sup = subToSuper.get(spl[0]);
						if (sup == null) {
							subToSuper.put(spl[0],sup = new ArrayList<>());
						}
						sup.add(spl[1]);
						input.append("?"+s+"\n");
					} else if (s.startsWith(":")) {
						String[] spl = s.substring(1).split(":",2);
						eclassUris.put(spl[0], spl[1]);
						input.append("?"+s+"\n");
					}
				}
				reader.close();
				
			} catch (IOException e1) {
				
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		
	
		
		StringBuilder output = new StringBuilder();
		try {
			final PipedOutputStream pos = new PipedOutputStream();
			final PipedInputStream pis = new PipedInputStream();
			final PipedInputStream is = new PipedInputStream(pos);
			final PipedOutputStream os = new PipedOutputStream(pis);
			final BufferedReader reader = new BufferedReader(new InputStreamReader(is));
			
			
			new Thread(new Runnable() {
				
				@Override
				public void run() {
					try {
						
						final BufferedReader reader = new BufferedReader(new InputStreamReader(pis));
						BufferedWriter writer = new BufferedWriter(new PrintWriter(pos));
						AnnotationIface.doMain(reader, writer);
						writer.flush();
						writer.close();
						reader.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
						System.err.println(e.getMessage());
					}
				}
			}).start();
			
			
			os.write(input.toString().getBytes());
			os.flush();
			os.close();
			
			String s;
			StringBuilder cur = new StringBuilder();
			Map<String,String> packageToJavaMap = new HashMap<>();
			String curName = null;
			
			File id = res;
			try {
				while ((s = reader.readLine()) != null) {
					output.append(s);
					output.append("\n");
					if (s.isEmpty()) {continue;}
					if (s.startsWith("+")) {
						if (curName != null) {
							packageToJavaMap.put(curName, cur.toString());
							cur = new StringBuilder();
						}
						curName = s.substring(1);
					} else if (s.startsWith("#")) {
						cur.append(s.substring(1));
						cur.append("\n");
					}
					
				}
			} catch (Exception e) {System.err.println(e.getMessage());}
			
			
			if (curName != null) {
				packageToJavaMap.put(curName, cur.toString());
			}

			
			for (Entry<String,String> entry: packageToJavaMap.entrySet()) {
				System.out.println("Writing source file " + entry.getKey()+":\n"+entry.getValue());
				if (entry.getKey().endsWith("info-txt")) {
					int lastPoint = entry.getKey().lastIndexOf('.');
					String pkg = "";
					String name = entry.getKey().replace('-', '.');
					if (lastPoint != -1) {
						pkg = entry.getKey().substring(0,lastPoint);
						name = entry.getKey().substring(lastPoint+1).replace('-', '.');
					}
					File fo = new File("src"+File.separator+pkg.replace('.', File.separatorChar)+File.separator+name);
					System.err.println("Writing to file " + fo.getPath());
					fo.getParentFile().mkdirs();
					Writer writer = new FileWriter(fo);
					writer.write(entry.getValue());
					writer.flush();
					writer.close();
				} else {
					File file = new File("src"+File.separator+entry.getKey().replace('.', File.separatorChar)+".java");
					file.getParentFile().mkdirs();
					Writer writer = new FileWriter(file);
					writer.write(entry.getValue());
					
					writer.flush();
					writer.close();
				}
			}
			
			reader.close();
			
			System.out.println(output.toString());
			
		} catch (IOException e) {
			System.err.println(e.getMessage());
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}
	
	public static class EcoreVMClone {
		public EcoreVMClone(String name, String... ecoreFiles) {
			this.name = name;
			this.ecoreFiles = ecoreFiles;
		}
		
		private String name;
		private String name() {return name;}
		
		private String[] ecoreFiles;
		private String[] ecoreFiles() {return ecoreFiles;}
		
		public String toString() {
			StringBuilder ret = new StringBuilder();
			ret.append("+");
			ret.append(name);
			ret.append("\n");
			for (String ecoreFile: ecoreFiles) {
				ret.append("#");
				ret.append(ecoreFile);
				ret.append("\n");
			}
			return ret.toString();
		}
	}
	
	public static void main(String[] args) {
		EcoreVMClone ps = new EcoreVMClone("PrimSec", "C:\\Users\\Robert\\workspaceCosimo\\VerOCL\\model\\prim.ecore",
				"C:\\Users\\Robert\\workspaceCosimo\\VerOCL\\model\\second.ecore");
		EcoreVMClone su = new EcoreVMClone("SecUni", "C:\\Users\\Robert\\workspaceCosimo\\VerOCL\\model\\second.ecore","C:\\Users\\Robert\\workspaceCosimo\\VerOCL\\model\\univ.ecore");
		EcoreVMClone all = new EcoreVMClone("AllSchool", "C:\\Users\\Robert\\workspaceCosimo\\VerOCL\\model\\prim.ecore",
				"C:\\Users\\Robert\\workspaceCosimo\\VerOCL\\model\\second.ecore","C:\\Users\\Robert\\workspaceCosimo\\VerOCL\\model\\univ.ecore");
		mainMethod2(Collections.singletonList(ps));
		mainMethod2(Collections.singletonList(su));
		mainMethod2(Collections.singletonList(all));
		
		
	}
}
