package #<outputClass.pkg.name>;

import #<outputClass.pkg.name>.virtual.ModelFactory;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class CloneState {
	public CloneState(#managerType manager, ModelFactory factory, Map<BasicObject,BasicObject> clonedMap) {
		this.manager = manager;
		this.factory = factory;
		this.clonedMap = clonedMap;
	}
	
	ModelFactory factory;
	#managerType manager;
	Map<BasicObject,BasicObject> clonedMap = new HashMap<>();
	
	public BasicObject getCloned(BasicObject from) {
		return clonedMap.get(from);
	}
	
	public ModelFactory getFactory() {
		return factory;
	}
	
	public <A extends BasicObject> A clone(A from) {
		return ((A)from.cloneNew(this));
	}
	
	public <A extends BasicObject> Collection<A> clone(Collection<A> from) {
		Collection<A> ret;
		if (from instanceof Set) {
			ret = new HashSet<A>();
		} else {
			ret = new ArrayList<A>();
		}
		for (A fro: from) {
			ret.add((A)fro.cloneNew(this));
		}
		return ret;
	}
	
	public <A> A ensureSingle(Collection<A> from) {
		if (from.isEmpty()) {
			return null;
		}
		return from.iterator().next();
	}
	
	public <A> A ensureSingle(Class<A> clazz, Collection from) {
		for (Object o: from) {
			if (o != null && clazz.isAssignableFrom(o.getClass())) {
				return (A)o;
			}
		}
		return null;
	}
	
	public <A> Collection<A> ensureCol(Class<A> clazz, Collection from) {
		Collection<A> ret = new ArrayList<>();
		for (Object o: from) {
			if (o != null && clazz.isAssignableFrom(o.getClass())) {
				ret.add((A)o);
			}
		}
		return ret;
	}
	
	public <A> A ensureBasic(Class<A> clazz, Object from) {
		if (from != null && clazz.isAssignableFrom(from.getClass())) {
			return (A)from;
		}
		return null;
	}
	
}